// Copyright 2017 The go-hep Authors.  All rights reserved.
// Use of this source code is governed by a BSD-style
// license that can be found in the LICENSE file.

package heppdt

const (
	PDG_d                             int = 1
	PDG_anti_d                        int = -1
	PDG_u                             int = 2
	PDG_anti_u                        int = -2
	PDG_s                             int = 3
	PDG_anti_s                        int = -3
	PDG_c                             int = 4
	PDG_anti_c                        int = -4
	PDG_b                             int = 5
	PDG_anti_b                        int = -5
	PDG_t                             int = 6
	PDG_anti_t                        int = -6
	PDG_l                             int = 7
	PDG_anti_l                        int = -7
	PDG_h                             int = 8
	PDG_anti_h                        int = -8
	PDG_g                             int = 21
	PDG_e_minus                       int = 11
	PDG_e_plus                        int = -11
	PDG_nu_e                          int = 12
	PDG_anti_nu_e                     int = -12
	PDG_mu_minus                      int = 13
	PDG_mu_plus                       int = -13
	PDG_nu_mu                         int = 14
	PDG_anti_nu_mu                    int = -14
	PDG_tau_minus                     int = 15
	PDG_tau_plus                      int = -15
	PDG_nu_tau                        int = 16
	PDG_anti_nu_tau                   int = -16
	PDG_L_minus                       int = 17
	PDG_L_plus                        int = -17
	PDG_nu_L                          int = 18
	PDG_anti_nu_L                     int = -18
	PDG_gamma                         int = 22
	PDG_Z0                            int = 23
	PDG_W_plus                        int = 24
	PDG_W_minus                       int = -24
	PDG_Higgs0                        int = 25
	PDG_reggeon                       int = 28
	PDG_pomeron                       int = 29
	PDG_Z_prime0                      int = 32
	PDG_Z_prime_prime0                int = 33
	PDG_W_prime_plus                  int = 34
	PDG_W_prime_minus                 int = -34
	PDG_Higgs_prime0                  int = 35
	PDG_A0                            int = 36
	PDG_Higgs_plus                    int = 37
	PDG_Higgs_minus                   int = -37
	PDG_R0                            int = 40
	PDG_anti_R0                       int = -40
	PDG_specflav                      int = 81
	PDG_rndmflav                      int = 82
	PDG_anti_rndmflav                 int = -82
	PDG_phasespa                      int = 83
	PDG_c_minushadron                 int = 84
	PDG_anti_c_minushadron            int = -84
	PDG_b_minushadron                 int = 85
	PDG_anti_b_minushadron            int = -85
	PDG_t_minushadron                 int = 86
	PDG_anti_t_minushadron            int = -86
	PDG_Wvirt_plus                    int = 89
	PDG_Wvirt_minus                   int = -89
	PDG_diquark                       int = 90
	PDG_anti_diquark                  int = -90
	PDG_cluster                       int = 91
	PDG_string                        int = 92
	PDG_indep                         int = 93
	PDG_CMshower                      int = 94
	PDG_SPHEaxis                      int = 95
	PDG_THRUaxis                      int = 96
	PDG_CLUSjet                       int = 97
	PDG_CELLjet                       int = 98
	PDG_table                         int = 99
	PDG_pi0                           int = 111
	PDG_pi_plus                       int = 211
	PDG_pi_minus                      int = -211
	PDG_pi_diffr_plus                 int = 210
	PDG_pi_diffr_minus                int = -210
	PDG_pi_2S0                        int = 20111
	PDG_pi_2S_plus                    int = 20211
	PDG_pi_2S_minus                   int = -20211
	PDG_eta                           int = 221
	PDG_eta_2S                        int = 20221
	PDG_eta_prime                     int = 331
	PDG_rho0                          int = 113
	PDG_rho_plus                      int = 213
	PDG_rho_minus                     int = -213
	PDG_rho_2S0                       int = 30113
	PDG_rho_2S_plus                   int = 30213
	PDG_rho_2S_minus                  int = -30213
	PDG_rho_3S0                       int = 40113
	PDG_rho_3S_plus                   int = 40213
	PDG_rho_3S_minus                  int = -40213
	PDG_omega                         int = 223
	PDG_omega_2S                      int = 30223
	PDG_phi                           int = 333
	PDG_a_00                          int = 10111
	PDG_a_0_plus                      int = 10211
	PDG_a_0_minus                     int = -10211
	PDG_f_0                           int = 10221
	PDG_f_prime_0                     int = 10331
	PDG_b_10                          int = 10113
	PDG_b_1_plus                      int = 10213
	PDG_b_1_minus                     int = -10213
	PDG_h_1                           int = 10223
	PDG_h_prime_1                     int = 10333
	PDG_a_10                          int = 20113
	PDG_a_1_plus                      int = 20213
	PDG_a_1_minus                     int = -20213
	PDG_f_1                           int = 20223
	PDG_f_prime_1                     int = 20333
	PDG_a_20                          int = 115
	PDG_a_2_plus                      int = 215
	PDG_a_2_minus                     int = -215
	PDG_f_2                           int = 225
	PDG_f_prime_2                     int = 335
	PDG_K0                            int = 311
	PDG_anti_K0                       int = -311
	PDG_K_S0                          int = 310
	PDG_K_L0                          int = 130
	PDG_K_plus                        int = 321
	PDG_K_minus                       int = -321
	PDG_K_star0                       int = 313
	PDG_anti_K_star0                  int = -313
	PDG_K_star_plus                   int = 323
	PDG_K_star_minus                  int = -323
	PDG_K_0_star0                     int = 10311
	PDG_anti_K_0_star0                int = -10311
	PDG_K_0_star_plus                 int = 10321
	PDG_K_0_star_minus                int = -10321
	PDG_K_10                          int = 10313
	PDG_anti_K_10                     int = -10313
	PDG_K_1_plus                      int = 10323
	PDG_K_1_minus                     int = -10323
	PDG_K_2_star0                     int = 315
	PDG_anti_K_2_star0                int = -315
	PDG_K_2_star_plus                 int = 325
	PDG_K_2_star_minus                int = -325
	PDG_K_prime_10                    int = 20313
	PDG_anti_K_prime_10               int = -20313
	PDG_K_prime_1_plus                int = 20323
	PDG_K_prime_1_minus               int = -20323
	PDG_D_plus                        int = 411
	PDG_D_minus                       int = -411
	PDG_D0                            int = 421
	PDG_anti_D0                       int = -421
	PDG_D_star_plus                   int = 413
	PDG_D_star_minus                  int = -413
	PDG_D_star0                       int = 423
	PDG_anti_D_star0                  int = -423
	PDG_D_0_star_plus                 int = 10411
	PDG_D_0_star_minus                int = -10411
	PDG_D_0_star0                     int = 10421
	PDG_anti_D_0_star0                int = -10421
	PDG_D_1_plus                      int = 10413
	PDG_D_1_minus                     int = -10413
	PDG_D_10                          int = 10423
	PDG_anti_D_10                     int = -10423
	PDG_D_2_star_plus                 int = 415
	PDG_D_2_star_minus                int = -415
	PDG_D_2_star0                     int = 425
	PDG_anti_D_2_star0                int = -425
	PDG_D_prime_1_plus                int = 20413
	PDG_D_prime_1_minus               int = -20413
	PDG_D_prime_10                    int = 20423
	PDG_anti_D_prime_10               int = -20423
	PDG_D_s_plus                      int = 431
	PDG_D_s_minus                     int = -431
	PDG_D_s_star_plus                 int = 433
	PDG_D_s_star_minus                int = -433
	PDG_D_s0_star_plus                int = 10431
	PDG_D_s0_star_minus               int = -10431
	PDG_D_s1_plus                     int = 10433
	PDG_D_s1_minus                    int = -10433
	PDG_D_s2_star_plus                int = 435
	PDG_D_s2_star_minus               int = -435
	PDG_D_prime_s1_plus               int = 20433
	PDG_D_prime_s1_minus              int = -20433
	PDG_B0                            int = 511
	PDG_anti_B0                       int = -511
	PDG_B_plus                        int = 521
	PDG_B_minus                       int = -521
	PDG_B_star0                       int = 513
	PDG_anti_B_star0                  int = -513
	PDG_B_star_plus                   int = 523
	PDG_B_star_minus                  int = -523
	PDG_B_0_star0                     int = 10511
	PDG_anti_B_0_star0                int = -10511
	PDG_B_0_star_plus                 int = 10521
	PDG_B_0_star_minus                int = -10521
	PDG_B_10                          int = 10513
	PDG_anti_B_10                     int = -10513
	PDG_B_1_plus                      int = 10523
	PDG_B_1_minus                     int = -10523
	PDG_B_2_star0                     int = 515
	PDG_anti_B_2_star0                int = -515
	PDG_B_2_star_plus                 int = 525
	PDG_B_2_star_minus                int = -525
	PDG_B_prime_10                    int = 20513
	PDG_anti_B_prime_10               int = -20513
	PDG_B_prime_1_plus                int = 20523
	PDG_B_prime_1_minus               int = -20523
	PDG_B_s0                          int = 531
	PDG_anti_B_s0                     int = -531
	PDG_B_s_star0                     int = 533
	PDG_anti_B_s_star0                int = -533
	PDG_B_s0_star0                    int = 10531
	PDG_anti_B_s0_star0               int = -10531
	PDG_B_s10                         int = 10533
	PDG_anti_B_s10                    int = -10533
	PDG_B_s2_star0                    int = 535
	PDG_anti_B_s2_star0               int = -535
	PDG_B_prime_s10                   int = 20533
	PDG_anti_B_prime_s10              int = -20533
	PDG_B_c_plus                      int = 541
	PDG_B_c_minus                     int = -541
	PDG_B_c_star_plus                 int = 543
	PDG_B_c_star_minus                int = -543
	PDG_B_c0_star_plus                int = 10541
	PDG_B_c0_star_minus               int = -10541
	PDG_B_c1_plus                     int = 10543
	PDG_B_c1_minus                    int = -10543
	PDG_B_c2_star_plus                int = 545
	PDG_B_c2_star_minus               int = -545
	PDG_B_prime_c1_plus               int = 20543
	PDG_B_prime_c1_minus              int = -20543
	PDG_eta_c                         int = 441
	PDG_eta_c_2S                      int = 20441
	PDG_J_psi                         int = 443
	PDG_psi_2S                        int = 20443
	PDG_chi_c0                        int = 10441
	PDG_chi_c1                        int = 10443
	PDG_chi_c2                        int = 445
	PDG_eta_b_2S                      int = 20551
	PDG_eta_b_3S                      int = 40551
	PDG_Upsilon                       int = 553
	PDG_Upsilon_2S                    int = 20553
	PDG_Upsilon_3S                    int = 60553
	PDG_Upsilon_4S                    int = 70553
	PDG_Upsilon_5S                    int = 80553
	PDG_h_b                           int = 10553
	PDG_h_b_2P                        int = 40553
	PDG_h_b_3P                        int = 100553
	PDG_chi_b0                        int = 551
	PDG_chi_b1                        int = 20553
	PDG_chi_b2                        int = 555
	PDG_chi_b0_2P                     int = 30551
	PDG_chi_b1_2P                     int = 50553
	PDG_chi_b2_2P                     int = 10555
	PDG_chi_b0_3P                     int = 50551
	PDG_chi_b1_3P                     int = 110553
	PDG_chi_b2_3P                     int = 20555
	PDG_eta_b2_1D                     int = 40555
	PDG_eta_b2_2D                     int = 60555
	PDG_Upsilon_1_1D                  int = 120553
	PDG_Upsilon_2_1D                  int = 30555
	PDG_Upsilon_3_1D                  int = 557
	PDG_Upsilon_1_2D                  int = 130553
	PDG_Upsilon_2_2D                  int = 50555
	PDG_Upsilon_3_2D                  int = 10557
	PDG_Delta_minus                   int = 1114
	PDG_anti_Delta_plus               int = -1114
	PDG_n_diffr                       int = 2110
	PDG_anti_n_diffr                  int = -2110
	PDG_n0                            int = 2112
	PDG_anti_n0                       int = -2112
	PDG_Delta0                        int = 2114
	PDG_anti_Delta0                   int = -2114
	PDG_p_diffr_plus                  int = 2210
	PDG_anti_p_diffr_minus            int = -2210
	PDG_p_plus                        int = 2212
	PDG_anti_p_minus                  int = -2212
	PDG_Delta_plus                    int = 2214
	PDG_anti_Delta_minus              int = -2214
	PDG_Delta_plus_plus               int = 2224
	PDG_anti_Delta_minus_minus        int = -2224
	PDG_Sigma_minus                   int = 3112
	PDG_anti_Sigma_plus               int = -3112
	PDG_Sigma_star_minus              int = 3114
	PDG_anti_Sigma_star_plus          int = -3114
	PDG_Lambda0                       int = 3122
	PDG_anti_Lambda0                  int = -3122
	PDG_Sigma0                        int = 3212
	PDG_anti_Sigma0                   int = -3212
	PDG_Sigma_star0                   int = 3214
	PDG_anti_Sigma_star0              int = -3214
	PDG_Sigma_plus                    int = 3222
	PDG_anti_Sigma_minus              int = -3222
	PDG_Sigma_star_plus               int = 3224
	PDG_anti_Sigma_star_minus         int = -3224
	PDG_Xi_minus                      int = 3312
	PDG_anti_Xi_plus                  int = -3312
	PDG_Xi_star_minus                 int = 3314
	PDG_anti_Xi_star_plus             int = -3314
	PDG_Xi0                           int = 3322
	PDG_anti_Xi0                      int = -3322
	PDG_Xi_star0                      int = 3324
	PDG_anti_Xi_star0                 int = -3324
	PDG_Omega_minus                   int = 3334
	PDG_anti_Omega_plus               int = -3334
	PDG_Sigma_c0                      int = 4112
	PDG_anti_Sigma_c0                 int = -4112
	PDG_Sigma_c_star0                 int = 4114
	PDG_anti_Sigma_c_star0            int = -4114
	PDG_Lambda_c_plus                 int = 4122
	PDG_anti_Lambda_c_minus           int = -4122
	PDG_Xi_c0                         int = 4132
	PDG_anti_Xi_c0                    int = -4132
	PDG_Sigma_c_plus                  int = 4212
	PDG_anti_Sigma_c_minus            int = -4212
	PDG_Sigma_c_star_plus             int = 4214
	PDG_anti_Sigma_c_star_minus       int = -4214
	PDG_Sigma_c_plus_plus             int = 4222
	PDG_anti_Sigma_c_minus_minus      int = -4222
	PDG_Sigma_c_star_plus_plus        int = 4224
	PDG_anti_Sigma_c_star_minus_minus int = -4224
	PDG_Xi_c_plus                     int = 4322
	PDG_anti_Xi_c_minus               int = -4322
	PDG_Xi_prime_c0                   int = 4312
	PDG_Xi_primeanti__c0              int = -4312
	PDG_Xi_c_star0                    int = 4314
	PDG_anti_Xi_c_star0               int = -4314
	PDG_Xi_prime_c_plus               int = 4232
	PDG_Xi_primeanti__c_minus         int = -4232
	PDG_Xi_c_star_plus                int = 4324
	PDG_anti_Xi_c_star_minus          int = -4324
	PDG_Omega_c0                      int = 4332
	PDG_anti_Omega_c0                 int = -4332
	PDG_Omega_c_star0                 int = 4334
	PDG_anti_Omega_c_star0            int = -4334
	PDG_Sigma_b_minus                 int = 5112
	PDG_anti_Sigma_b_plus             int = -5112
	PDG_Sigma_b_star_minus            int = 5114
	PDG_anti_Sigma_b_star_plus        int = -5114
	PDG_Lambda_b0                     int = 5122
	PDG_anti_Lambda_b0                int = -5122
	PDG_Xi_b_minus                    int = 5132
	PDG_anti_Xi_b_plus                int = -5132
	PDG_Sigma_b0                      int = 5212
	PDG_anti_Sigma_b0                 int = -5212
	PDG_Sigma_b_star0                 int = 5214
	PDG_anti_Sigma_b_star0            int = -5214
	PDG_Sigma_b_plus                  int = 5222
	PDG_anti_Sigma_b_minus            int = -5222
	PDG_Sigma_star_                   int = 5224
	PDG_anti_Sigma_b_star_minus       int = -5224
	PDG_Xi_b0                         int = 5232
	PDG_anti_Xi_b0                    int = -5232
	PDG_Xi_prime_b_minus              int = 5312
	PDG_anti_Xi_prime_b_plus          int = -5312
	PDG_Xi_b_star_minus               int = 5314
	PDG_anti_Xi_b_star_plus           int = -5314
	PDG_Xi_prime_b0                   int = 5322
	PDG_anti_Xi_prime_b0              int = -5322
	PDG_Xi_b_star0                    int = 5324
	PDG_anti_Xi_b_star0               int = -5324
	PDG_Omega_b_minus                 int = 5332
	PDG_anti_Omega_b_plus             int = -5332
	PDG_Omega_b_star_minus            int = 5334
	PDG_anti_Omega_b_star_plus        int = -5334
	PDG_dd_0                          int = 1101
	PDG_anti_dd_0                     int = -1101
	PDG_ud_0                          int = 2101
	PDG_anti_ud_0                     int = -2101
	PDG_uu_0                          int = 2201
	PDG_anti_uu_0                     int = -2201
	PDG_sd_0                          int = 3101
	PDG_anti_sd_0                     int = -3101
	PDG_su_0                          int = 3201
	PDG_anti_su_0                     int = -3201
	PDG_ss_0                          int = 3301
	PDG_anti_ss_0                     int = -3301
	PDG_cd_0                          int = 4101
	PDG_anti_cd_0                     int = -4101
	PDG_cu_0                          int = 4201
	PDG_anti_cu_0                     int = -4201
	PDG_cs_0                          int = 4301
	PDG_anti_cs_0                     int = -4301
	PDG_cc_0                          int = 4401
	PDG_anti_cc_0                     int = -4401
	PDG_bd_0                          int = 5101
	PDG_anti_bd_0                     int = -5101
	PDG_bu_0                          int = 5201
	PDG_anti_bu_0                     int = -5201
	PDG_bs_0                          int = 5301
	PDG_anti_bs_0                     int = -5301
	PDG_bc_0                          int = 5401
	PDG_anti_bc_0                     int = -5401
	PDG_bb_0                          int = 5501
	PDG_anti_bb_0                     int = -5501
	PDG_dd_1                          int = 1103
	PDG_anti_dd_1                     int = -1103
	PDG_ud_1                          int = 2103
	PDG_anti_ud_1                     int = -2103
	PDG_uu_1                          int = 2203
	PDG_anti_uu_1                     int = -2203
	PDG_sd_1                          int = 3103
	PDG_anti_sd_1                     int = -3103
	PDG_su_1                          int = 3203
	PDG_anti_su_1                     int = -3203
	PDG_ss_1                          int = 3303
	PDG_anti_ss_1                     int = -3303
	PDG_cd_1                          int = 4103
	PDG_anti_cd_1                     int = -4103
	PDG_cu_1                          int = 4203
	PDG_anti_cu_1                     int = -4203
	PDG_cs_1                          int = 4303
	PDG_anti_cs_1                     int = -4303
	PDG_cc_1                          int = 4403
	PDG_anti_cc_1                     int = -4403
	PDG_bd_1                          int = 5103
	PDG_anti_bd_1                     int = -5103
	PDG_bu_1                          int = 5203
	PDG_anti_bu_1                     int = -5203
	PDG_bs_1                          int = 5303
	PDG_anti_bs_1                     int = -5303
	PDG_bc_1                          int = 5403
	PDG_anti_bc_1                     int = -5403
	PDG_bb_1                          int = 5503
	PDG_anti_bb_1                     int = -5503

	// SUSY Particles, names modified from /Control/AthenaCommon/PDGTABLE.MeV
	// naming convention change
	//      '~' to 's_'
	//      '(' to '_'
	//      ')' to nothing
	//      '+' to 'plus'
	//      ',' to '_'
	//      for the negatively charged particles, so I add "minus" to the name and a corresponding "plus" entry with -pdg code
	//      for the neutrals, I add a corresponding "anti" entry with -pdg code
	//      for the particles with positive charge entries, I add a corresponding "minus" entry with -pdg code
	// ************ (the above is not consistant with the convention that minus =particle, plus =anti-particle
	//
	//      Next, remove Majorana particles, and rename L-R stau to mass eigen states.
	//
	//      This is all ugly, but sort of consistant with previous naming convention

	PDG_s_e_minus_L int = 1000011
	PDG_s_e_plus_L  int = -1000011

	PDG_s_nu_e_L      int = 1000012
	PDG_s_anti_nu_e_L int = -1000012

	PDG_s_mu_minus_L int = 1000013
	PDG_s_mu_plus_L  int = -1000013

	PDG_s_nu_mu_L      int = 1000014
	PDG_s_anti_nu_mu_L int = -1000014

	//    PDG_s_tau_minus_L  int =1000015
	//    PDG_s_tau_plus_L   int =-1000015

	// L-R mixing significant, use _1 and _2 for names instead
	PDG_s_tau_minus_1 int = 1000015
	PDG_s_tau_plus_1  int = -1000015

	PDG_s_nu_tau_L         int = 1000016
	PDG_s_anti_nu_tau_Lint     = -1000016

	PDG_s_e_minus_R int = 2000011
	PDG_s_e_plus_R  int = -2000011

	PDG_s_mu_minus_R int = 2000013
	PDG_s_mu_plus_R  int = -2000013

	PDG_s_tau_minus_2 int = 2000015
	PDG_s_tau_plus_2  int = -2000015

	PDG_s_g int = 1000021
	//    PDG_s_anti_g       int =-1000021 // Majorana

	PDG_s_chi_0_1 int = 1000022
	//    PDG_s_anti_chi_0_1 int =-1000022 // Majorana

	PDG_s_chi_0_2 int = 1000023
	//    PDG_s_anti_chi_0_2 int =-1000023 // Majorana

	PDG_s_chi_plus_1  int = 1000024
	PDG_s_chi_minus_1 int = -1000024 // Majorana

	PDG_s_chi_0_3 int = 1000025
	//    PDG_s_anti_chi_0_3 int =-1000025 // Majorana

	PDG_s_chi_0_4 int = 1000035
	//    PDG_s_anti_chi_0_4 int =-1000035 // Majorana

	PDG_s_chi_plus_2  int = 1000037
	PDG_s_chi_minus_2 int = -1000037

	PDG_s_G int = 1000039
	//    PDG_s_anti_G       int =-1000039 // Majorana

	// note mismatch with PDGTable and pre-existing PdtPdg.h
	//M     999                          0.E+00         +0.0E+00 -0.0E+00 Geantino        0
	//W     999                          0.E+00         +0.0E+00 -0.0E+00 Geantino        0

	// doubly charged Higgs
	PDG_Higgs_plus_plus_L   int = 9900041
	PDG_Higgs_minus_minus_L int = -9900041
	PDG_Higgs_plus_plus_R   int = 9900042
	PDG_Higgs_minus_minus_R int = -9900042

	/// Null particles
	PDG_deuteron int = 0
	PDG_tritium  int = 0
	PDG_alpha    int = 0
	PDG_geantino int = 0
	PDG_He3      int = 0
	PDG_Cerenkov int = 0
	PDG_null     int = 0
)
